//		This file is a part of TI Ching.
//
//    TI Ching - Produces and displays I Ching hexagrams.
//    Copyright (C) 2007  David E. Shere (tree.pomegranate@gmail.com)
//
//    TI Ching is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//   	TI Ching is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

// Header File

//This function (ShowImg) is based off of code from a TICT tutorial.
//ShowImg useful for displaying large pictures or full screen displays
//It is modified from its original version by William M Hilton
//The original author was:
	/******************************************************************************
	*                                                                             
	* T I C T   T U T O R I A L S                                                 
	*                                                                                                                                                         
	* Executive Editor: thomas.nussbaumer@gmx.net                                 
	* Homepage:         http://go.to/tichess                                      
	*                                                                                                                                                          
	* ----------------------------------------------------------------------------- 
	*                                                                                                                                                                                                                                       
	* SERIES 1 - Basic Techniques                                                 
	*                                                                             
	* PART I: Handling Uncompressed Images in C-Projects  v 1.00                  
	*
	*
	* Release Date: 14/08/2000                                                    
	******************************************************************************/

/*  Modified by David E. Shere on August 8, 2007  for use with TI Ching */

#define USE_GRAY_PATCH   // use grayscale patch

/*---------------------------------------------------------------------------*/
/* includes (NOTE: I don't use all.h, but include just the necessary files)  */
/*---------------------------------------------------------------------------*/
//#include <nostub.h>      // necessary for the nostub stuff
//#include <graph.h>       // for LCD_WIDTH definition
//#include <compat.h>      // for the TI89 definition
#include <mem.h>         // for memset() and memcpy()
#include "oldyin.h"
#include "yang.h"
#include "yin.h"
#include "oldyang.h"
#include "arrow.h"

void ShowImg(short x, short y, short width, short height, 
							unsigned char *image1) {

    unsigned char* plane1;
    unsigned char* dest1;
    unsigned char* src1;
    int            loop;

    //-----------------------------------------------
    // fetch start addresses of planes
    //-----------------------------------------------
    plane1 = GetPlane(0);

    dest1 = plane1;
    src1  = image1;
		
	/****Uncomment this part if you want to center the printout on*****
	*****a TI92 or Voyager. Otherwise, x and y will be relative   *****
	*****from the top left corner of the screen                   *****
		//-----------------------------------------------
    // on the TI92 we have to clear both bitplanes
    // because the skipped parts will be visible
    //
    // additionally we have to add an initial offset
    // to the destination pointers
    //----------------------------------------------- 
    if (!TI89) {
        memset(plane1,0,LCD_SIZE);
        memset(plane2,0,LCD_SIZE);

        //-------------------------------------------
        // setup the destination pointers taking the 
        // initial offset into account
        // (each line consists of 30 bytes on a TI92)
        //-------------------------------------------
        dest1 += ((128-100)*30)/2 + ((240-160)/8)/2;
        dest2 += ((128-100)*30)/2 + ((240-160)/8)/2;
    }
	*****                                                         *****
	*****                                                         ****/
	
    //-----------------------------------------------
    // ... and now copy all lines from the data 
    // arrays to the bitplanes
    //-----------------------------------------------
    for (loop=0;loop<height;loop++,src1+=width/8,dest1+=30) {
        memcpy(dest1+y*30+x/8,src1,width/8);
    }
}